{{ Wirf mir mal die Butter rber }}

{{  
Demonstration eines Aufrufschemas fr Prozesse und ihre Kommunikation.

Das Hauptprogramm definiert einen Pool von Daten.

Es werden verschiedene Prozesse gestartet, die einen Zeiger erhalten, der auf einen Prozesscontrolblock
verweist. Der Block besteht aus Zeigern auf Variable. Die erste Variable ist das Prozesskommando.

Die weiteren sind programmspezifisch und ihre Bedeutung muss bekannt sein.
Die Kommunikation zwischen den Prozessen erfolgt nach einen einfachen Schema:

  Ist das Kommando fr Prozess N auf dem Wert 0, kann es beschrieben werden.
  Kennt man den Zustand des Prozesses N nicht, empfiehlt sich das Kommanodo "Idle". Damit wird der
  Prozess N in den Ruhezustand gebracht. Dieser ist gegeben, wenn das Kommando mit 0 quittiert wird.

  Dieses Protokoll funktioniert nur, wenn klar ist, wer wem Kommandos gibt und es keine berschneidungen
  gibt. Ansonsten muss man Semaphoren einbauen!
  
  Der Prozess N kennt zwei grundlegende Arbeitsweisen: Ein Kommando wird erkannt und ausgefhrt, danach
  ist der Prozess wieder Idle. Wird die Quittung nach Abschluss gegeben ist damit sichergestellt, dass
  auch die Eingangsvariablen wieder frei sind.
  Weise zwei: Kommando wird erkannt, Parameter werden bernommen, Kommando quittiert und dann eine Funktion
  so lange ausgefhrt, bis eine Endebedingung oder ein Idle-Kommando erkannt wird.

  Daneben gibt es noch eine dritte Weise: man macht es so, wie man gerade Lust hat. 
}}



CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

'Allen Prozessen gemeinsame Kommandos:
  #1, Idle, Run, Disp

   
'Fr die Visualisierung unter Windows: PC-Interface & Graphik
  #0, WHITE,CYAN,RED,PINK,BLUE,GREEN,YELLOW,GRAY        'Standard colors
  
  
' Visualisierung
  ColA = red
  ColB = green
  ColC = blue 
  ColD = yellow
  ColE = cyan
  ColF = pink 
  ColG = white 
  ColH = white 

  
OBJ
          
  term     : "PCAscii_Interface"  ' Graphik (0,0) links oben
  Wrfr     : "Werfer"             ' Ein Butterwerfer
  Bttr     : "Butter"             ' Die Butter
  Fngr     : "Faenger"            ' Der Fnger
   
VAR
  long   ch
DAT
VersDate byte  "08.05.2008 A na", 0


                             

MsgCol       long  Yellow  ' Voreingestellte Farbe fr eine Message
MsgXpo       long  5       ' Voreingestellte Spalte fr eine Message
MsgYpo       long  31      ' Voreingestellte Zeile fr eine Message


CON      AnzBttrPar = 7 ' Wertezeiger fr die Butter
Dat ProzBttr word  @BttrCmd, @BttrDisp, @XBttrNeu, @YBttrNeu, @dXBttr, @dYBttr, @YWrfrNeu  

CON      AnzWrfrPar = 6 ' Wertezeiger fr den Werfer
Dat ProzWrfr word  @WrfrCmd, @WrfrDisp, @YWrfrNeu, @dXBttr,   @dYBttr, @BttrCmd               

CON      AnzFngrPar = 5 ' Wertezeiger fr den Fnger
Dat ProzFngr word  @FngrCmd, @FngrDisp, @YFngrNeu, @XBttrNeu, @YBttrNeu               
           

BttrCmd     long  0                                                                                   
WrfrCmd     long  0                                                                                   
FngrCmd     long  0



BttrDisp  long  0               
WrfrDisp  long  0               
FngrDisp  long  0               

YWrfrAlt  long 20
YWrfrNeu  long 20
           
YFngrAlt  long 20
YFngrNeu  long 20

XBttrAlt long 20
XBttrNeu long 20
dXBttr   long  1
YBttrAlt long 20
YBttrNeu long 20
dYBttr   long  1

' Folgende Daten zur Dokumentation von Zeit und Datum des Programmlaufes
Time        long  0   ' Counter als aktuelle Zeit
TimeStrg    byte 0, 0, 0, 0, 0, 0, 0, 0, 0
DateStrg    byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
TimeRequ    byte 5, $81, 2, 2, 0
DateRequ    byte 5, $81, 3, 3, 0
StV001      byte    "18.11.2998", 0, "b8.11.2998", 0        ' StV001 Datumsstring 
StV002      byte    "13:33:34",   0, "b3:33:34",   0        ' StV002 Uhrzeit 
LocCol      long  Yellow  ' Werte fr eine aktuelle Liste von Elementen
LocXpo      long  5       ' 
LocYpo      long  31      ' 
                                                                  
PUB Main | i, AktStat

  
  i:= term.start(31,30)             'start the interface   
  term.cls
                   
  repeat while (term.abs_x == 0)    'wait for PropTerminal.exe started

  makeTxtScreen                   ' Bildschirm Text aufbauen, lscht auch Graphik
  DocCog (  CogID+1, String("MainProgramm"))
  DocCog (  i      , String("Terminal   "))

  ' Zuerst einmal alle Prozesse starten und in Idle laufen lassen

  BttrCmd := AnzBttrPar     ' Damit kann ButterStart die richtige Anzahl Pointer initialisieren
  repeat i from 0 to AnzBttrPar -1           ' Kompensiert den Offset. "Richtige" Lsung ist nicht parat
    ProzBttr[ i] += 16
  i := Bttr.start(@ProzBttr) ' Butter starten
  DocCog ( i       , String("Die Butter  "))
'  AktStat := CmdInvok (@BttrCmd, Run, 0)

  WrfrCmd := AnzWrfrPar     ' Damit kann WerferStart die richtige Anzahl Pointer initialisieren
  repeat i from 0 to AnzWrfrPar -1           ' Kompensiert den Offset. "Richtige" Lsung ist nicht parat
    ProzWrfr[ i] += 16
  i := Wrfr.start(@ProzWrfr) ' Butter starten
  DocCog ( i       , String("Der Werfer  "))
  AktStat := CmdInvok (@WrfrCmd, Run, 0)

  FngrCmd := AnzFngrPar     ' Damit kann FaengerStart die richtige Anzahl Pointer initialisieren
  repeat i from 0 to AnzFngrPar -1           ' Kompensiert den Offset. "Richtige" Lsung ist nicht parat
    ProzFngr[ i] += 16
  i := Fngr.start(@ProzFngr) ' Butter starten
  DocCog ( i       , String("Der Fnger  "))
  AktStat := CmdInvok (@FngrCmd, Run, 0)

  term.setcol(Red)
  term.box (  10, YWrfrAlt, 10, 10)
  YWrfrNeu := YWrfrAlt 
     
  term.setcol(Green)
  term.box ( 410, YFngrAlt, 10, 10)
  YFngrNeu := YFngrAlt 

  term.setcol(Yellow)
  term.box ( XBttrAlt, YBttrAlt, 10, 10) 
  XBttrNeu := XBttrAlt
  YBttrNeu := YBttrAlt

'  term.setcol(White)
   

' DIE HAUPTSCHLEIFE
  repeat 100


    repeat

      Display
      waitcnt(clkfreq/50 + cnt)
      UpDDateTime
    
Pri  Display | j, AktStat

   if WrfrDisp
     term.invbox ( 10, YWrfrAlt, 10, 10) 
     term.invbox ( 10, YWrfrNeu, 10, 10) 
     YWrfrAlt := YWrfrNeu
     WrfrDisp := 0   ' Display quittiert die Bewegung an Werfer

   if FngrDisp
     term.invbox ( 410, YFngrAlt, 10, 10) 
     term.invbox ( 410, YFngrNeu, 10, 10) 
     YFngrAlt := YFngrNeu
     FngrDisp := 0   ' Display quittiert die Bewegung an Fnger

   if BttrDisp
     term.invbox ( XBttrAlt, YBttrAlt, 10, 10) 
     term.invbox ( XBttrNeu, YBttrNeu, 10, 10) 
     XBttrAlt := XBttrNeu
     YBttrAlt := YBttrNeu
     BttrDisp := 0   ' Display quittiert die Bewegung an Butter

   ' Datum und Uhrzeit
   LocXpo := 5 
   j :=  @StV001 
   
   if NOT StrComp (@byte[j], @byte[j+ StrSize(@byte[j])+ 1])  ' Falls neuer Wert: Ausgabe und Altwert aktualisieren

     CPMessage (LocCol, LocXpo, LocYpo, @byte[j]) 
     ByteMove (@byte[j+ StrSize(@byte[j])+ 1], @byte[j], StrSize(@byte[j]))

   LocXpo := 20 
   j :=  @StV002 
   
   if NOT StrComp (@byte[j], @byte[j+ StrSize(@byte[j])+ 1])  ' Falls neuer Wert: Ausgabe und Altwert aktualisieren

     CPMessage (LocCol, LocXpo, LocYpo, @byte[j]) 
     ByteMove (@byte[j+ StrSize(@byte[j])+ 1], @byte[j], StrSize(@byte[j]))

    
Pub  CmdInvok (CmdPtr, Cmd, Stat) ' Schreibt das Kommando Cmd auf die passende Speicherstelle
     long[CmdPtr] := Cmd  
     repeat while long[CmdPtr]
'     PutStat ( Stat )     ' PutStat gibt den Status aus
     Result := Stat
     
PRI  PutStat ( Zust )   ' PutStat gibt den Status aus
     PutVal ( 50,  0,  "#", ":", Zust )
     Result := Zust
     

PRI DocCog (i, StrPtr)
    CPMessage (Green, 65, 15+i, StrPtr)

PRI MakeTxtScreen  | i
  term.cls
'  term.setcol (0)'(gray)

  DocCog ( 1, String("COG 0 frei"))
  DocCog ( 2, String("COG 1 frei"))
  DocCog ( 3, String("COG 2 frei"))
  DocCog ( 4, String("COG 3 frei"))
  DocCog ( 5, String("COG 4 frei"))
  DocCog ( 6, String("COG 5 frei"))
  DocCog ( 7, String("COG 6 frei"))
  DocCog ( 8, String("COG 7 frei"))
  
  CPMessage (Yellow,  2, 27, String("Wirf mir mal die Butter rber ! "))
  term.Str  (@VersDate)


PRI PutVal (px, py, Char1, Char2, val1)
    setpos(px, py)
    term.out(Char1)
    term.out(Char2)
    term.dec(val1)
    
      

PRI setpos(px, py)

  term.out(10)
  term.out(px)
  term.out(11)
  term.out(py)


PRI CPOut (Col, xpo, ypo, byVal) 
      term.setcol(Col)
      setpos (xpo, ypo)
      term.out(byVal)      ' Einzelnes Byte ausgeben

'      CPMessage (Green, 35,  3, String("Y"))

PRI CPMessage  (Col, xp, yp, StrPtr)
    setpos     (xp, yp)
    term.setcol(Col)
    term.str   (StrPtr)

PRI PMessage   (xp, yp, StrPtr)
    setpos     (xp, yp)
    term.setcol(MsgCol)
    term.str   (StrPtr)

PRI CMessage   (Col, StrPtr)
    setpos     (MsgXpo, MsgYpo)
    term.setcol(Col)
    term.str   (StrPtr)

PRI Message    (StrPtr)
    PMessage   (MsgXpo, MsgYpo, StrPtr)

PRI UpDDateTime | i 
   
  if DateStrg[0] == 0   ' Das Datum initial, Datum & Uhrzeit vom PC lesen
    term.clearkeys
    term.Str(@TimeRequ)
    i := 0
    repeat while ( ch := term.getkey) <> 13
      TimeStrg[i] := ch
      i++
    term.Str (@DateRequ)
    i := 1
    repeat while ( ch := term.getkey) <> 13
      DateStrg[LookUp(i: 3, 4, 2, 0, 1, 5, 6, 7, 8, 9)] := ch
      i++
    DateStrg[5] := "."  
    Time := cnt
    bytemove (@StV001, @DateStrg, StrSize (@StV001))

   
  if Cnt > Time  ' Alle Sekunde die Zeit aktualisieren und ausgeben
    Time += ClkFreq

    TimeStrg[7] ++
    if TimeStrg[7] == $3A
       TimeStrg[7] := $30

      TimeStrg[6] ++
      if TimeStrg[6] == $36
         TimeStrg[6] := $30

        TimeStrg[4] ++
        if TimeStrg[4] == $3A
           TimeStrg[4] := $30

          TimeStrg[3] ++
          if TimeStrg[3] == $36
             TimeStrg[3] := $30

            TimeStrg[1] ++
            if TimeStrg[1] == $3A OR ((TimeStrg[0] == $32) AND (TimeStrg[1] == $34))
               TimeStrg[1] := $30

              TimeStrg[0] ++
              if (TimeStrg[0] == $33)  
                TimeStrg[0] := $30
                TimeStrg[1] := $30

    bytemove (@StV002, @TimeStrg, StrSize (@StV002))





  